Index: nsMsgCompose.cpp
===================================================================
RCS file: /cvsroot/mozilla/mailnews/compose/src/nsMsgCompose.cpp,v
retrieving revision 1.549
diff -u -r1.549 nsMsgCompose.cpp
--- nsMsgCompose.cpp	16 Feb 2008 15:31:32 -0000	1.549
+++ nsMsgCompose.cpp	19 Feb 2008 09:27:49 -0000
@@ -633,8 +633,6 @@
       htmlEditor->RebuildDocumentFromSource(aBuf);
       mInsertingQuotedContent = PR_FALSE;
 
-      m_editor->EndOfDocument();
-
       // when forwarding a message as inline, tag any embedded objects
       // which refer to local images or files so we know not to include
       // send them
@@ -642,10 +640,25 @@
         (void)TagEmbeddedObjects(mailEditor);
 
       if (!aSignature.IsEmpty())
+      {
+        if (sigOnTop)
+          m_editor->BeginningOfDocument();
+        else
+          m_editor->EndOfDocument();
         htmlEditor->InsertHTML(aSignature);
+        if (sigOnTop)
+          m_editor->EndOfDocument();
+      }
+      else
+        m_editor->EndOfDocument();
     }
     else if (textEditor)
     {
+      if (sigOnTop && !aSignature.IsEmpty()) {
+        textEditor->InsertText(aSignature);
+        m_editor->EndOfDocument();
+      }
+
       if (!aBuf.IsEmpty())
       {
         if (mailEditor)
@@ -655,7 +668,7 @@
         m_editor->EndOfDocument();
       }
 
-      if (!aSignature.IsEmpty())
+      if (!sigOnTop && !aSignature.IsEmpty())
         textEditor->InsertText(aSignature);
     }
   }
@@ -4064,36 +4077,43 @@
 
   /* Some time we want to add a signature and sometime we wont. Let's figure that now...*/
   PRBool addSignature;
+  PRBool addDashes;
   switch (mType)
   {
+    case nsIMsgCompType::ForwardInline :
+      addSignature = PR_TRUE;
+      addDashes = PR_TRUE;
+      break;
     case nsIMsgCompType::New :
     case nsIMsgCompType::MailToUrl :    /* same as New */
     case nsIMsgCompType::Reply :        /* should not happen! but just in case */
     case nsIMsgCompType::ReplyAll :       /* should not happen! but just in case */
     case nsIMsgCompType::ReplyToList :    /* should not happen! but just in case */
     case nsIMsgCompType::ForwardAsAttachment :  /* should not happen! but just in case */
-    case nsIMsgCompType::ForwardInline :
     case nsIMsgCompType::NewsPost :
     case nsIMsgCompType::ReplyToGroup :
     case nsIMsgCompType::ReplyToSender :
     case nsIMsgCompType::ReplyToSenderAndGroup :
       addSignature = PR_TRUE;
+      addDashes = PR_FALSE;
       break;
 
     case nsIMsgCompType::Draft :
     case nsIMsgCompType::Template :
       addSignature = PR_FALSE;
+      addDashes = PR_FALSE;
       break;
 
     default :
       addSignature = PR_FALSE;
+      addDashes = PR_FALSE;
       break;
   }
 
   nsAutoString tSignature;
 
   if (addSignature)
-    ProcessSignature(m_identity, PR_FALSE, &tSignature);
+    ProcessSignature(m_identity, addDashes, &tSignature);
 
   // if type is new, but we have body, this is probably a mapi send, so we need to
   // replace '\n' with <br> so that the line breaks won't be lost by html.
